//
//  Closures.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 19.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

func closures() {
	
	let names = ["Willi", "Claus", "Franky", "Peter", "Heinz"]
	
	func backwards(nameA: String, _ nameB: String) -> Bool {
		return nameA > nameB
	}
	
	var namesSorted = names.sort(backwards)
	print("Sortierte Namen: \(namesSorted)")
	
	namesSorted = names.sort({ (nameA: String, nameB: String) -> Bool in
		return nameA > nameB
	})
	print("Sortierte Namen: \(namesSorted)")

	namesSorted = names.sort({ (nameA: String, nameB: String) -> Bool in return nameA > nameB })
	print("Sortierte Namen: \(namesSorted)")

	namesSorted = names.sort( { nameA, nameB in return nameA > nameB } )
	print("Sortierte Namen: \(namesSorted)")

	namesSorted = names.sort( { nameA, nameB in nameA > nameB } )
	print("Sortierte Namen: \(namesSorted)")

	namesSorted = names.sort( { $0 > $1 } )
	print("Sortierte Namen: \(namesSorted)")

	namesSorted = names.sort(>)
	print("Sortierte Namen: \(namesSorted)")

	namesSorted = names.sort(<)
	print("Sortierte Namen: \(namesSorted)")

	let incrementSix = makeIncrementer(forIncrement: 6)
	print(incrementSix())
	print(incrementSix())
	print(incrementSix())
	print(incrementSix())
	print(incrementSix())

	let incrementFour = makeIncrementer(forIncrement: 4)
	print(incrementFour())
	print(incrementFour())
	print(incrementFour())

	print(incrementSix())
	print(incrementFour())

}

func makeIncrementer(forIncrement amount: Int) -> () -> Int {
	var total = 0
	
	func incremenenter() -> Int {
		total += amount
		return total
	}
	
	return incremenenter
}
