//
//  ControlFlow.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 19.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

func controlFlow() {
	forLoops()
	whileLoops()
	conditionalStatements()
	
	let kunden = [4711 : "Willi", 4712 : "Franky"]
	earlyExit(kunden[4713])

	deferStatement()
	apiAvailability()
}

func apiAvailability() {
	if #available(iOS 9, *) {
		print("iOS9")
	} else {
		print("wir müssen es anders machen")
	}
}

func deferStatement() {
	defer {
		print("ich bin jetzt fertig mit deferStatement()")
	}
	defer {
		print("Das muss auch noch gemacht werden")
	}

	print("Aktion 1")
	
	let checkState = Int("0")!
	
	if checkState == 1 {
		print("Wichtige Sache, ich muss weg....")
		return
	}

	for i in 0 ... 5 {
		print(i)
	}

	if checkState == 2 {
		print("Noch so ein Ding")
		return
	}

	print("Aktion 2")
}

func earlyExit(name: String?) {
	guard let name = name else { return }

	print("name des Kunden = \(name)")
	
//	if name == nil { return }
//	
//	if let name = name {
//		print("name des Kunden = \(name)")
//	}
}

func conditionalStatements () {
	let temperatureInFahrenheit = Int("90")!

	if temperatureInFahrenheit <= 32 {
		print("kalt hier")
	} else if temperatureInFahrenheit >= 86 {
		print("Das ist sehr heiß")
	} else {
		print("Ist Ok")
	}
	
	switch temperatureInFahrenheit {

	case Int.min ... 32:
		print("kalt hier")
		
	case 86 ... Int.max - 1:
		print("Das ist sehr heiß")
		
	default:
		print("Ist Ok")
	
	}

	let state = Int("2")!
	switch state {
	case 0:
		print("Null")
	case 1, 2, 3:
		print("zwischen Eins und Drei")
	default:
		print("ist irgend etwas anderes")
	}

	
	let x = Int("-3")!
	let y = Int("-3")!
	
	let point = (x, y)
	
	switch point {
	case (0, 0):
		print("Ursprung")

	case (_, 0):
		print("y == 0")

	case (0, _):
		print("x == 0")
		
	case (-2...2, -2...2):
		print("ja, wir haben den Bereich")
		
	default:
		print("x = \(point.0), y = \(point.1)")
	}
	
	switch point {
		
	case let(x, y) where x == y:
		print("x == y")
		
	case let(x, y) where x != y:
		print("x != y")
		
	case let(x, y):
		print("x = \(x) y = \(y)")
	}
	
	printTypeName(123.456)
}

func printTypeName(thing: Any) {
	
	switch thing {
	case is Int:
		print("Ein Int")
		
	case let value as Double:
		print("Ein Double: \(value * 2)")
		
	case is Float:
		print("Ein Float")
		
	case is String:
		print("Ein String")
		
	default:
		print("was anderes")
	}
	
}

func whileLoops() {
	print(__FUNCTION__)
	
	var counter = 0
	while counter++ < 5 {
		print("counter = \(counter)")
	}
	
	repeat {
		print("repeat counter = \(counter)")
	} while --counter >= 0
}

func forLoops() {
	print(__FUNCTION__)
	
	// der alte hässliche Weg, der nicht mehr beschritten werden soll
	for var i = 0; i < 5; i = i + 1 {
		print(i)
	}
	
	for i in 0 ..< 5 {
		print(i)
	}

	for _ in 1 ... 4 {
		print("hallo")
	}

}