//
//  Enumerations.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 19.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

enum Color {
	case Red
	case Green
	case Blue
	case Yellow
}

enum Result {
	case Ok
	case Error(String)
}

enum Planet: Int {
	case Mercury = 10
	case Venus
	case Earth	 = 20
	case Mars	 = 30
	case Jupiter
	case Saturn
	case Uranus
	case Neptune
}

enum Thing: String {
	case Car, Bike, Computer
}

enum TriStateSwitch {
	case Off
	case Low
	case High
	
	mutating func next() {
		switch self {
		case Off:
			self = Low
		case Low:
			self = High
		case High:
			self = Off
		}
	}
}

func enumerations() {
	
	switch getColor() {
	case .Red:
		print("Rot")
	case .Green:
		print("Grün")
	case .Blue:
		print("Blau")
	case .Yellow:
		print("Gelb")
	}
	
	switch calculate() {
	case .Ok:
		print("Alles gut. Prima")

	case .Error(let errorMessage) where errorMessage == "file not found!":
		print("Mist, Datei nicht gefunden")

	case .Error(let errorMessage) where errorMessage == "server not found!":
		print("Mist, Server nicht gefunden")
		
	case .Error(let errorMessage):
		print("irgendein anderer Fehler: \(errorMessage)")
	}
	
	switch getPlanet() {
	case .Earth:
		print("Schön, die Erde")
	case .Mars:
		print("Schön, der Mars")
	default:
		print("irgendein anderer Planet")
	}
	
	let planet = getPlanet()
	print(planet.rawValue)

	print(getThing())
	
	var airCondition = TriStateSwitch.Off
	print(airCondition)
	
	airCondition.next()
	print(airCondition)

	airCondition.next()
	print(airCondition)

	airCondition.next()
	print(airCondition)
	
	airCondition.next()
	print(airCondition)
}

func getThing() -> Thing {
	return Thing(rawValue: "Computer")!
}

func getColor() -> Color {
	return .Red
}

func getPlanet() -> Planet {
	return Planet(rawValue: 30)!
}

func calculate() -> Result {
	return .Error("no WLAN")
}

