//
//  ErrorHandling.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 19.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

enum UnserFehler:ErrorType {
	case KeinPlatzAufPlatte
	case KeinNetzwerk
	case UserEingeschlafen
	case WasAnderes(String)
}

func kannEinenFehlerWerfen(wert: Int) throws {

	if wert == 1 {
		throw UnserFehler.KeinPlatzAufPlatte
	} else if wert == 2 {
		throw UnserFehler.UserEingeschlafen
	} else if wert == 3 {
		throw UnserFehler.WasAnderes("Keine Ahnung, hat eben nicht funktioniert")
	}

	print("alles ok, kein Fehler")
}

func errorHandling() {
	do {
		print("Tolle Aktionen....")
		
		try kannEinenFehlerWerfen(3)
		
		print("Andere wichtige Dinge...")
		
	} catch UnserFehler.KeinPlatzAufPlatte {
		print("Schade, du hättest doch das dickere iPhone kaufen sollen")

	} catch UnserFehler.UserEingeschlafen {
		print("Das ist zu dieser Stunde auch absolut legitim")
	
	} catch {
		print("Hm, das war jetzt etwas, was nicht besonders behandelt wird: \(error)")
	}
}

func machMalWas() throws -> Int {
	print("ich habs gemacht")
	
	let a = Int("3")!
	
	if a == 3 {
		throw NSError(domain: "Das ging schief", code: 1999, userInfo: nil)
	}
	
	return 42
}

func komplizierterAblaufInDerApp() {
//	let rueckgabe = try? machMalWas()
//	print(rueckgabe)
	
	do {
		print("vorher machen wir was")
		
		let ergebnis = try machMalWas()
		
		print("danach machen wir auch tolle Sachen: \(ergebnis)")
		
	} catch {
		print("Problem: \(error)")
	}
}