//
//  Functions.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 19.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

func functions() {
	let hello = sayHello("Franky", withAge: 46)
	print("sayHello: \(hello)")
	
	let ergebnis = summe(x: 17, y: 5, z: 1)
	print("\(ergebnis)")
	
	printHello("Franky")
	
	print("\(greeting("Willi"))")
	
	print(sum(5, 4, 3, 2, 8))
	
	var a = 5
	let b = 4
	let result = berechnung(&a, b: b)
	print(result)
	
	print("a = \(a)")
	print("b = \(b)")
	
	var mathFunction: (Int, Int) -> Int = multiply
	print(mathFunction(5, 5))

	mathFunction = add
	print(mathFunction(5, 5))
	
	mathResult(5, b: 5, mathFunction: add)
	mathResult(5, b: 5, mathFunction: multiply)

	mathResult(5, b: 5, mathFunction: { (a: Int, b:Int) -> Int in
		return a - b
	})

	mathResult(5, b: 5) { (a: Int, b:Int) -> Int in
		return a - b
	}

	mathResult(5, b: 5) { (a, b) -> Int in
		return a - b
	}

	mathResult(5, b: 5) { (a, b) -> Int in
		a - b
	}

	mathResult(5, b: 5) { $0 - $1 }

	mathResult(10, b: 2) { $0 / $1 }

	var currentPosition = -8
	let stepper = chooseStepFunction(currentPosition > 0)
	
	print("zurück zu 0")
	
	while currentPosition != 0 {
		print(currentPosition)
		currentPosition = stepper(currentPosition)
	}
	print("Null !!!!")
}

func chooseStepFunction(backwards: Bool) -> (Int) -> Int {
	
	func stepForward (input: Int) -> Int { return input + 1 }
	func stepBackward(input: Int) -> Int { return input - 1 }

	return backwards ? stepBackward : stepForward
}

func mathResult(a: Int, b: Int, mathFunction:(Int, Int) -> Int) {
	print("Ergebnis = \(mathFunction(a, b))")
}

func add(a: Int, _ b: Int) -> Int {
	return a + b
}

func multiply(a: Int, _ b: Int) -> Int {
	return a * b
}


func berechnung(inout a: Int, b: Int) -> Int {
	a = a * b
	
	return a + 17
}

func sum(numbers: Int...) -> Int {
	//return numbers.reduce(0) { $0 + $1 }

	var total = 0
	for number in numbers {
		total += number
	}
	return total
}

func summe(x x: Int = 0, y: Int = 0, z: Int = 0) -> Int {
	return x + y + z
}

func sayHello(personName: String, withAge age: Int) -> String {
	let greeting = "Hello, " + personName + "!" + " your age: \(age)"
	return greeting
}

func printHello(personName: String) {
	print(personName)
}

func greeting(name: String) -> String? {
	switch name {
	case "Franky":
		return "hello, Franky"
	case "Willi":
		return "hello, Willo"
	default:
		return nil
	}
}