//
//  Protocols.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 20.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

protocol Tier {
	var name: String { get }
	func gibLaut() -> String
	func bewegen()
}

extension Tier {
	func bewegen() {
		print("ich habe mich bewegt")
	}
}

struct Hund: Tier {
	var name: String = "Bello"

	func gibLaut() -> String {
		return "wauWau"
	}
	
	func bewegen() {
		print("ich bin weitergedackelt")
	}
}

class Katze: Tier {
	var name: String = "DJ"

	func gibLaut() -> String {
		return "miau"
	}
}

func tierCheck(tier: Tier) {
	print("Mein Name ist \(tier.name) und ich mache \(tier.gibLaut())")
	tier.bewegen()
}

func protocols() {
	let hund = Hund()
	let katze = Katze()
	
	tierCheck(hund)
	tierCheck(katze)
}