//
//  Subscripts.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 20.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

class DreiWuerfel: CustomStringConvertible {
	var wuerfel1 = 1
	var wuerfel2 = 1
	var wuerfel3 = 1
	
	var description: String {
		return "\(wuerfel1) \(wuerfel2) \(wuerfel3)"
	}
	
	func wuerfeln() {
		wuerfel1 = Int(arc4random_uniform(6)) + 1
		wuerfel2 = Int(arc4random_uniform(6)) + 1
		wuerfel3 = Int(arc4random_uniform(6)) + 1
	}
	
	subscript(index: Int) -> Int {
		get {
			if index == 0 {
				return wuerfel1
			} else if index == 1 {
				return wuerfel2
			} else {
				return wuerfel3
			}
		}
		set {
			if index == 0 {
				wuerfel1 = newValue
			} else if index == 1 {
				wuerfel2 = newValue
			} else {
				wuerfel3 = newValue
			}
		}
	}
}

func subscripts() {
	let wuerfel = DreiWuerfel()
	wuerfel.wuerfeln()

	print(wuerfel)
	for i in 0 ..< 3 {
		print(wuerfel[i])
	}
	
	wuerfel[0] = 4
	print(wuerfel)
	
}