//
//  TextFieldViewController.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 20.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import UIKit

protocol TextFieldViewControllerDelegate {
	func textFieldViewController(textFieldViewController: TextFieldViewController, hasText text: String)
}

class TextFieldViewController: UIViewController {

	@IBOutlet weak var textFieldOutlet: UITextField!

	var delegate: TextFieldViewControllerDelegate?

	override func viewWillDisappear(animated: Bool) {
		super.viewWillDisappear(animated)
		delegate?.textFieldViewController(self, hasText: textFieldOutlet.text ?? "")
	}
	
	deinit {
		print("TextFieldViewController muss weg")
	}
	
	override func viewDidAppear(animated: Bool) {
		super.viewDidAppear(animated)
		textFieldOutlet.becomeFirstResponder()
	}
}
