//
//  TypeCasting.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 20.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import Foundation

class MediaItem {
	var name: String

	init(name: String) {
		self.name = name
	}
}

class Movie: MediaItem {
	var director: String

	init(name: String, director: String) {
		self.director = director
		super.init(name: name)
	}
}

class Song: MediaItem {
	var artist: String
	
	init(name: String, artist: String) {
		self.artist = artist
		super.init(name: name)
	}
}

func typeCasting() {
	let library = [
		Movie(name: "Casablanca", director: "Michael Curtiz"),
		Song(name: "Blue Seude Shoes", artist: "Elvis Presley"),
		Movie(name: "Citizen Kane", director: "Orson Welles"),
		Song(name: "The One And Only", artist: "Chesney Hawkes"),
		"Walter",
		"willis",
	]
	
	var movieCount = 0
	var songCount = 0
	
	for item in library {
		if item is Movie {
			movieCount++
		} else if item is Song {
			songCount++
		}
	}
	
	print("movies: \(movieCount), songs: \(songCount)")

	for item in library {
		if let movie = item as? Movie {
			print("name: \(movie.name), director: \(movie.director)")

		} else if let song = item as? Song {
			print("name: \(song.name), artist: \(song.artist)")
		}
	}

}