//
//  ViewController.swift
//  Optional-1249
//
//  Created by Frank Jüstel on 19.12.15.
//  Copyright © 2015 JSM Arts. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

	// MARK: - outlets
	@IBOutlet weak var labelOutlet: UILabel! {
		didSet {
			labelOutlet.text = "drück den Button"
		}
	}
	@IBOutlet weak var redSliderOutlet: UISlider!
	@IBOutlet weak var greenSliderOutlet: UISlider!
	@IBOutlet weak var blueSliderOutlet: UISlider!
	
	// MARK: - view livecycle
	override func viewDidLoad() {
		super.viewDidLoad()
		
		registerUserDefaults()
	}
	
	override func viewWillAppear(animated: Bool) {
		super.viewWillAppear(animated)
		restoreSliderValues()
		colorFromSliders()
	}
	
	// MARK: - methods
	func colorFromSliders() {
		view.backgroundColor = UIColor(red: CGFloat(redSliderOutlet.value), green: CGFloat(greenSliderOutlet.value), blue: CGFloat(blueSliderOutlet.value), alpha: 1.0)
	}
	
	func persistSliderValues() {
		let defaults = NSUserDefaults.standardUserDefaults()
		
		defaults.setFloat(redSliderOutlet.value, forKey: "red")
		defaults.setFloat(greenSliderOutlet.value, forKey: "green")
		defaults.setFloat(blueSliderOutlet.value, forKey: "blue")
		
		defaults.synchronize()
	}
	
	func registerUserDefaults() {
		let defaults = NSUserDefaults.standardUserDefaults()
		defaults.registerDefaults([
			"red" : Float(1),
			"blue" : Float(1),
			"green" : Float(1)
		])
	}
	
	func restoreSliderValues() {
		let defaults = NSUserDefaults.standardUserDefaults()
		redSliderOutlet.value = defaults.floatForKey("red")
		greenSliderOutlet.value = defaults.floatForKey("green")
		blueSliderOutlet.value = defaults.floatForKey("blue")
	}
	
	// MARK: - actions
	@IBAction func buttonAction(sender: UIButton) {
		labelOutlet.text = "hello, world!"
	}

	@IBAction func colorSliderValueChanged(sender: AnyObject) {
		colorFromSliders()
		persistSliderValues()
	}

	override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
		if segue.identifier == "toTextFieldViewContrroller" {
			let controller = segue.destinationViewController as! TextFieldViewController
			controller.delegate = self
		}
	}
	
}

// MARK: - TextFieldViewControllerDelegate
extension ViewController: TextFieldViewControllerDelegate {
	func textFieldViewController(textFieldViewController: TextFieldViewController, hasText text: String) {
		labelOutlet.text = text
	}
}
